#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with program; see the file COPYING. If not,
# write to the Free Software Foundation, Inc., 59 Temple Place
# - Suite 330, Boston, MA 02111-1307, USA.
#
# Copyright 2002-2005 Free Software Foundation
#
# FILE:
# GFContainer.py
#
# DESCRIPTION:
"""
A base class for all GFObjects that can receive focus on the UI
"""

from gnue.common import events

from GFObj import GFObj

class GFTabStop(GFObj):
  """
  A base class for all GFObjects that can receive focus on the UI
  """
  
  _navigable = True

  def __init__(self, parent, type):
    GFObj.__init__(self, parent, type)
    
    # The sub-event handler handles the events that are passed from
    # the GFInstance.  This is the event handler that display handlers 
    self.subEventHandler = events.EventController()

  def isNavigable(self, mode="edit"):
    # TODO: Check for read-only, etc
    if mode == 'query':
      return self._navigable and self._queryable
    else:
      return (self._navigable) and (not self.readonly)

